package com.javacodegeeks.ultimate.aws.eb;

import org.glassfish.jersey.logging.LoggingFeature;
import org.junit.Ignore;
import org.junit.Test;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.GenericType;
import javax.ws.rs.core.Response;

import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import static org.hamcrest.core.Is.is;
import static org.hamcrest.core.IsCollectionContaining.hasItem;
import static org.junit.Assert.assertThat;

public class TutorialIntegrationTest {

    private static final Logger LOGGER = Logger.getLogger(TutorialIntegrationTest.class.getName());

    @Test
    @Ignore
    public void testListAllCourses() {
        Client client = ClientBuilder.newClient();
        WebTarget target = client.target("http://localhost:8080").path("/tomcat-web-service/tomcat-web-service/tutorial/list-all-courses");
        Response response = target.request().get();
        assertThat(response.getStatus(), is(200));
        List<Tutorial> tutorials = response.readEntity(new GenericType<List<Tutorial>>(){});
        assertThat(tutorials.size(), is(3));
        assertThat(tutorials, hasItem(new Tutorial("Linus Meyer", "Linux")));
        assertThat(tutorials, hasItem(new Tutorial("Bill Famous", "Microsoft")));
        assertThat(tutorials, hasItem(new Tutorial("Josh Hotspot", "Java")));
    }

    @Test
    public void testListAllTables() {
        Client client = ClientBuilder.newClient();
        WebTarget target = client.target("http://localhost:8080").path("/tomcat-web-service/tomcat-web-service/db/remove-all-tables");
        Response response = target.request().get();
        assertThat(response.getStatus(), is(200));
        target = client.target("http://localhost:8080").path("/tomcat-web-service/tomcat-web-service/db/list-all-tables");
        response = target.request().get();
        assertThat(response.getStatus(), is(200));
        List<String> tutorials = response.readEntity(new GenericType<List<String>>(){});
        assertThat(tutorials.size(), is(0));
    }

    @Test
    public void testAddTutorial() {
        Client client = ClientBuilder.newClient();
        client.register(new LoggingFeature(LOGGER, Level.INFO, null, null));
        WebTarget target = client.target("http://localhost:8080").path("/tomcat-web-service/tomcat-web-service/db/remove-all-tables");
        Response response = target.request().get();
        assertThat(response.getStatus(), is(200));
        target = client.target("http://localhost:8080").path("/tomcat-web-service/tomcat-web-service/db/create-all-tables");
        response = target.request().get();
        assertThat(response.getStatus(), is(200));
        target = client.target("http://localhost:8080").path("/tomcat-web-service/tomcat-web-service/tutorial/add-tutorial");
        response = target.request().post(Entity.json(new Tutorial("Bean", "JPA")));
        assertThat(response.getStatus(), is(200));
        target = client.target("http://localhost:8080").path("/tomcat-web-service/tomcat-web-service/tutorial/list-all-courses").queryParam("author", "Bean");
        response = target.request().get();
        assertThat(response.getStatus(), is(200));
        List<Tutorial> tutorials = response.readEntity(new GenericType<List<Tutorial>>(){});
        assertThat(tutorials.size(), is(1));
        target = client.target("http://localhost:8080").path("/tomcat-web-service/tomcat-web-service/db/remove-all-tables");
        response = target.request().get();
        assertThat(response.getStatus(), is(200));
    }
}